# we don't want to provide private python extension libs
%define _exclude_files_from_autoprov %{python2_sitearch}/.*\\.so\\|%{python3_sitearch}/.*\\.so
%global _disable_ld_no_undefined 1

%define sname       PyQt5
%define sip_ver     4.19.23
%define qt5_minver  5.15.2

Name:       python-qt5
Version:    5.15.6
Release:    %mkrel 4
Summary:    Set of Python bindings for Trolltech's Qt application framework
Group:      Development/Python
License:    GPLv2+
URL:        http://www.riverbankcomputing.co.uk/software/pyqt/intro
Source0:    %{sname}-%{version}.tar.xz
Source2:    pylupdate5.sh
Source3:    pyrcc5.sh
Source4:    pyuic5.sh
Patch0:     PyQt5-sip4-compat.patch

BuildRequires:  lib64qt5base5-devel
BuildRequires:  lib64qt5bluetooth-devel
BuildRequires:  lib64qt5core-devel
BuildRequires:  lib64qt5dbus-devel
BuildRequires:  lib64qt5designer-devel
BuildRequires:  lib64qt5gui-devel
BuildRequires:  lib64qt5help-devel
BuildRequires:  lib64qt5location-devel
BuildRequires:  lib64qt5multimedia-devel
BuildRequires:  lib64qt5multimediawidgets-devel
BuildRequires:  lib64qt5network-devel
BuildRequires:  lib64qt5networkauth-devel
BuildRequires:  lib64qt5nfc-devel
BuildRequires:  lib64qt5opengl-devel
BuildRequires:  lib64qt5positioning-devel
BuildRequires:  lib64qt5printsupport-devel
BuildRequires:  lib64qt5multimediagsttools-devel
BuildRequires:  lib64qt5qml-devel
BuildRequires:  lib64qt5quick-devel
BuildRequires:  lib64qt5quick3d-devel
BuildRequires:  lib64qt5quickwidgets-devel
BuildRequires:  lib64qt5remoteobjects-devel
BuildRequires:  lib64qt5sensors-devel
BuildRequires:  lib64qt5serialport-devel
BuildRequires:  lib64qt5sql-devel
BuildRequires:  lib64qt5svg-devel
BuildRequires:  lib64qt5test-devel
BuildRequires:  lib64qt5texttospeech-devel
BuildRequires:  lib64qt5webchannel-devel
BuildRequires:  lib64qt5webkit-devel
BuildRequires:  lib64qt5webkitwidgets-devel
BuildRequires:  lib64qt5websockets-devel
BuildRequires:  lib64qt5widgets-devel
BuildRequires:  lib64qt5xml-devel
BuildRequires:  lib64qt5xmlpatterns-devel
BuildRequires:  lib64qt5x11extras-devel

BuildRequires:  python-sip6
BuildRequires:  python3-pyqt-builder
BuildRequires: python3-pkg-resources
BuildRequires: python3-setuptools
BuildRequires: python3-toml
BuildRequires: python3-packaging
BuildRequires: python3-pyparsing

%description
PyQt is a set of Python bindings for Trolltech's Qt application framework

%define py3_name    python3-qt5

%package -n python3-qt5
Summary:        Python 3 bindings for Qt5
Group:          Development/Python

BuildRequires:  python3-devel
#sip4 breaks the build
#BuildRequires:  python3-sip-devel
BuildRequires:  python3-pyqt5-sip
BuildRequires:  python-dbus-devel

Provides:      python3-PyQt5 = %version-%release
Provides:      %{py3_name}-core = %{version}
Provides:      %{py3_name}-dbus = %{version}
Provides:      %{py3_name}-bluetooth = %{version}
Provides:      %{py3_name}-designer = %{version}
Provides:      %{py3_name}-gui = %{version}
Provides:      %{py3_name}-location = %{version}
Provides:      %{py3_name}-multimedia = %{version}
Provides:      %{py3_name}-multimediawidgets = %{version}
Provides:      %{py3_name}-nfc = %{version}
Provides:      %{py3_name}-network = %{version}
Provides:      %{py3_name}-networkauth = %{version}
Provides:      %{py3_name}-opengl = %{version}
Provides:      %{py3_name}-positioning = %{version}
Provides:      %{py3_name}-printsupport = %{version}
Provides:      %{py3_name}-qml = %{version}
Provides:      %{py3_name}-quick = %{version}
Provides:      %{py3_name}-quick3d = %{version}
Provides:      %{py3_name}-quickwidgets = %{version}
Provides:      %{py3_name}-remoteobjects = %{version}
Provides:      %{py3_name}-sensors = %{version}
Provides:      %{py3_name}-serialport = %{version}
Provides:      %{py3_name}-sql = %{version}
Provides:      %{py3_name}-svg = %{version}
Provides:      %{py3_name}-test = %{version}
Provides:      %{py3_name}-texttospeech = %{version}
Provides:      %{py3_name}-webchannel = %{version}
Provides:      %{py3_name}-webkit = %{version}
Provides:      %{py3_name}-webkitwidgets = %{version}
Provides:      %{py3_name}-websockets = %{version}
Provides:      %{py3_name}-widgets = %{version}
Provides:      %{py3_name}-xml = %{version}
Provides:      %{py3_name}-xmlpatterns = %{version}
Provides:      %{py3_name}-x11extras = %{version}

Requires:       python3-dbus

BuildConflicts: python3-sip
BuildConflicts: python3-sip-devel

%description -n python3-qt5
Python 3 bindings for Qt5.

%package -n %{py3_name}-examples
Summary:        PyQt 5 examples
Group:          Development/Python
BuildArch:      noarch

%description -n %{py3_name}-examples
PyQt 5 examples.

%package -n    %{py3_name}-devel
Summary:       Python 3 bindings for PyQt 5 devel
Group:         Development/Python
Requires:      %{py3_name}
Requires:      qttools5-designer


%description -n %{py3_name}-devel
Python 3 bindings for PyQt 5 devel utilities.
Files needed to build other bindings for C++ classes that inherit from any
of the Qt5 classes (e.g. KDE or your own).

%prep
%setup -qn %{sname}-%{version}
%apply_patches

%build
export PATH=%{_qt5_bindir}:$PATH

sip-build \
  --no-make \
  --qt-shared \
  --confirm-license \
  --api-dir=%{_qt5_datadir}/qsci/api/python \
  --verbose \
  --dbus=%{_includedir}/dbus-1.0/ \
  --pep484-pyi \
  --qmake-setting 'QMAKE_CFLAGS_RELEASE="%{optflags}"' \
  --qmake-setting 'QMAKE_CXXFLAGS_RELEASE="%{optflags} `pkg-config --cflags dbus-python`"' \
  --qmake-setting 'QMAKE_LFLAGS_RELEASE="%{?__global_ldflags}"'

%make_build -C build

%install
### python3-qt5 install
%make_install INSTALL_ROOT=%{buildroot} -C build
rm -fr %{buildroot}%{python3_sitearch}/PyQt5/uic/port_v2

# ensure .so modules are executable for proper -debuginfo extraction
for i in %{buildroot}%{python3_sitearch}/PyQt5/*.so %{buildroot}%{python3_sitearch}/dbus/mainloop/pyqt5.abi3.so ; do
chmod a+rx $i
done

mkdir -p %{buildroot}%{_docdir}/%{py3_name}

mkdir %{buildroot}%{_docdir}/%{py3_name}/examples
    cp -fr examples/* %{buildroot}%{_docdir}/%{py3_name}/examples/

# Python shebang
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" %{buildroot}%{_docdir}/%{py3_name}/examples/*

# no need to package QtMacExtras, QtWinExtras, QtAndroidExtras and Enginio
rm -rfv %{buildroot}#%{_datadir}/python3-sip/PyQt5/QtMacExtras
rm -rfv %{buildroot}#%{_datadir}/python3-sip/PyQt5/QtWinExtras
rm -rfv %{buildroot}#%{_datadir}/python3-sip/PyQt5/QtAndroidExtras
rm -rfv %{buildroot}#%{_datadir}/python3-sip/PyQt5/Enginio

### install pyuic5 wrapper to handle both/either python2/python3
rm -fv %{buildroot}%{_bindir}/{pyrcc5,pylupdate5,pyuic5}
install -p -m 0755 -D %{SOURCE2} %{buildroot}%{_bindir}/pylupdate5
install -p -m 0755 -D %{SOURCE3} %{buildroot}%{_bindir}/pyrcc5
install -p -m 0755 -D %{SOURCE4} %{buildroot}%{_bindir}/pyuic5
sed -i \
  -e "s|@PYTHON3@|%{__python3}|g" \
  -e "s|@PYTHON2@|%{__python2}|g" \
  %{buildroot}%{_bindir}/{pyrcc5,pylupdate5,pyuic5}

# symlink bindings for compatibility with sip4
mkdir -p %{buildroot}%{_datadir}/python3-sip
ln -s %{python3_sitearch}/PyQt5/bindings %{buildroot}%{_datadir}/python3-sip/PyQt5

%files -n python3-qt5
%{python3_sitearch}
%{_datadir}/python3-sip/PyQt5
%{_qt5_datadir}/qsci/*
%{_qt5_plugindir}/PyQt5/libpyqt5qmlplugin.so

%files -n %{py3_name}-examples
%{_datadir}/doc

%files -n %{py3_name}-devel
%{_bindir}/py*
%{_qt5_plugindir}/designer/*

%pre -n python3-qt5
rm -rf /usr/share/python3-sip/PyQt5


%changelog
* Tue Aug 02 2022 tex - 5.15.6-4pclos2022
- try to fix again

* Tue Aug 02 2022 tex - 5.15.6-3pclos2022
- try to fix specfile

* Sun Jul 31 2022 TerryN <terryn94 at gmail.com> 5.15.6-2pclos2022
- symlink bindings for sip4 compatibility
- patch qt5core for sip4 compatibility

* Mon Mar 07 2022 TerryN <terryn94 at gmail.com> 5.15.6-1pclos2022
- update and rebuild for python 3.10

* Wed Feb 06 2019 tex - 5.11.3-3pclos2019
- rebuild against updates

